﻿#NoEnv
SendMode Input
SetWorkingDir, C:\Users\%A_Username%
#SingleInstance Force
CoordMode, Mouse, Screen
Menu, Tray, Add, Open GUI, open_gui

ParseMeeting(string) {
	MeetParts := StrSplit(string, " ")
	MeetPLen := MeetParts.Length()
	If (MeetPLen = 1)
		Return [MeetParts[1], ""]
	If (MeetPLen = 2)
		Return MeetParts
	Return ["", ""]
}
DumpSave(meeting) {
	MeetLen := meeting.Length()
	If (MeetLen = 2)
		Return meeting[1] . "," . meeting[2] . ","
	If (MeetLen = 3)
		Return meeting[1] . "," . meeting[2] . "," . meeting[3]
	Return ",,"
}
DoSave() {
	Global Meetings, SelectMeeting
	File := FileOpen(".meetings", "w")
	For I, M In Meetings {
		File.Write(DumpSave(M))
		File.Write("`n")
	}
	File.Close()
	GuiControl,, SelectMeeting, |Add New...
	For I, M In Meetings {
		MeetName := M[1]
		GuiControl,, SelectMeeting, %MeetName%
	}
}

Meetings := []
Loop, Read, .meetings
{
	Meetings.Push(StrSplit(A_LoopReadLine, ","))
}

^+!j::
open_gui:
Gui, Destroy
Gui, Add, Text,, Select a meeting:
Gui, Add, DDL, vSelectMeeting gOnMeetingSelected AltSubmit Choose1, Add New...
For I, M In Meetings {
	MeetName := M[1]
	GuiControl,, SelectMeeting, %MeetName%
}
Gui, Add, Text,, Meeting Nickname:
Gui, Add, Edit, r1 vIMeetingName
Gui, Add, Text,, Meeting ID:
Gui, Add, Edit, r1 vIMeetingID
Gui, Add, Text,, Meeting Password (if any):
Gui, Add, Edit, r1 vIMeetingPwd
Gui, Add, Button, -Wrap gOnJoinMeeting, Join meeting
Gui, Add, Button, -Wrap gOnSaveMeeting vISaveMeeting, Save meeting
Gui, Show
Return

OnSaveMeeting:
Gui, Submit, NoHide
If (SelectMeeting = 1) {
	Meetings.Push([IMeetingName, IMeetingID, IMeetingPwd])
	MeetingIndex := Meetings.Length() + 1
} Else {
	Meetings[SelectMeeting - 1] := [IMeetingName, IMeetingID, IMeetingPwd]
	MeetingIndex := SelectMeeting
}
DoSave()
GuiControl, Choose, SelectMeeting, %MeetingIndex%
Return

OnJoinMeeting:
Gui, Submit, NoHide
MeetDat := IMeetingID . " " . IMeetingPwd
Goto join_meeting

OnMeetingSelected:
Gui, Submit, NoHide
If (SelectMeeting = 1) {
	GuiControl,, IMeetingName,
	GuiControl,, IMeetingID,
	GuiControl,, IMeetingPwd,
} Else {
	MeetName := Meetings[SelectMeeting - 1][1]
	GuiControl,, IMeetingName, %MeetName%
	MeetID := Meetings[SelectMeeting - 1][2]
	GuiControl,, IMeetingID, %MeetID%
	MeetPwd := Meetings[SelectMeeting - 1][3]
	GuiControl,, IMeetingPwd, %MeetPwd%
}
Return

GuiEscape:
GuiClose:
Gui, Hide
DoSave()
Return

^+j::
InputBox, MeetDat, Join Meeting, Enter meeting ID and password (if any)`, separate by a space:
If (ErrorLevel)
	Return

join_meeting:
MeetArr := ParseMeeting(MeetDat)
MeetID := MeetArr[1]
MeetPwd := MeetArr[2]
MeetID := StrReplace(MeetID, "-")
Run, cmd.exe /c start wemeet://page/inmeeting?meeting_code=%MeetID%
If (MeetPwd = "")
	Return
Sleep, 5000
If (Not WinExist("腾讯会议"))
	Return
WinActivate ;, "腾讯会议"
Sleep, 2000
XPos := A_ScreenWidth * 0.5
YPos := A_ScreenHeight * 0.36
Click, %XPos%, %YPos%
SendRaw, %MeetPwd%
Send, {Enter}
Return
